//=============================================================================
// AM_Pickup.
//
// Author: Francesco Biscazzo
// Date: 2016
//=============================================================================
class AM_Pickup extends TournamentPickup;

var AdvancedMutator AM;
var Weapon OwnerWeapon;

function RegisterAdvancedMutator(AdvancedMutator AdvMut) {
	AM = AdvMut;
	
	GotoState('Activated');
	Activate();
	
	SetTimer(0.1, True);
}

state Activated
{
	function Activate() {
		bActive = true;
		SetOwnerWeapon();
	}

	function EndState()
	{
		bActive = false;
		GotoState('Idle2');
	}

	function BeginState()
	{
		bActive = true;
		SetOwnerWeapon();	
	}
	
	// Use getStateName() on the weapon to get the fire type.
	function FireEffect() {
		AM.Fired(Pawn(Owner), OwnerWeapon);
	}

	function OwnerJumped() {
		AM.Jumped(Pawn(Owner));
	}

	function ChangedWeapon()
	{
		local Weapon OldWeapon;

		OldWeapon = OwnerWeapon;
		super.ChangedWeapon();
		SetOwnerWeapon();
		
		AM.ChangedWeapon(Pawn(Owner), OldWeapon, OwnerWeapon);
	}

	function bool HandlePickupQuery( Inventory item )
	{
		AM.PickedUp(Pawn(Owner), item);
	}

	function SetOwnerWeapon()
	{
		if ( !bActive )
			return;

		// Make old weapon normal again.
		if ( OwnerWeapon != None )
		{
			OwnerWeapon.SetDefaultDisplayProperties();
			if ( OwnerWeapon.IsA('TournamentWeapon') )
				TournamentWeapon(OwnerWeapon).Affector = None;
		}
			
		OwnerWeapon = Pawn(Owner).Weapon;
		// Set new weapon as the OwnerWeapon.
		if ( OwnerWeapon != None )
		{
			if ( OwnerWeapon.IsA('TournamentWeapon') )
				TournamentWeapon(OwnerWeapon).Affector = self;
		}
	}

	function Timer()
	{
		if (Owner.IsA('Pawn'))
				Pawn(Owner).bCountJumps = true;

		if ( !Pawn(Owner).bAutoActivate )
			OwnerJumped();
	}
}