//=============================================================================
// AdvancedMutator.
//
// Author: Francesco Biscazzo
// Date: 2016
//=============================================================================
class AdvancedMutator extends Mutator;

function ModifyPlayer(Pawn Other)
{
	local AM_Pickup AMP;

	if ( Other.IsA('PlayerPawn') ) {
		if( Other.IsA('Spectator') || Other.FindInventoryType(class'AM_Pickup') != None )
			return;
		
		AMP = Spawn(class'AM_Pickup', Other);
		if (AMP != none) {
			AMP.bHeldItem = true;
			AMP.GiveTo( Other );
			Other.SelectedItem = AMP;
			AMP.PickupFunction(Other);
			
			AMP.RegisterAdvancedMutator(self);
		}
	}
	
	super.ModifyPlayer(Other);
}

function Fired(Pawn pawn, Weapon weapon) {
	//FIRETYPE CHECK BETA TEST
	local String fireType;
	
	fireType = String(weapon.getStateName());
	
	Level.Game.BroadcastMessage("[<Fired> | pawn:"@pawn$" | weapon:"@weapon$" | fireType:"@fireType$"]");
}

function Jumped(Pawn pawn) {
	Level.Game.BroadcastMessage("[<Jumped> | pawn:"@pawn$"]");
}

function ChangedWeapon(Pawn pawn, Weapon oldWeapon, Weapon newWeapon) {
	Level.Game.BroadcastMessage("[<ChangedWeapon> | pawn:"@pawn$" | oldWeapon:"@oldWeapon$" | newWeapon:"@newWeapon$"]");
}

function PickedUp(Pawn pawn, Inventory item) {
	Level.Game.BroadcastMessage("[<PickedUp> | pawn:"@pawn$" | item:"@item$"]");
}